#include <gtkmm.h>

#ifdef _WIN32
#include <gdk/gdkwin32.h>
#endif

#include "NoActivateWindow.h"

NoActivateWindow::NoActivateWindow()
: m_button("BUTTON")
{
	m_button.set_margin_top(20);
	m_button.set_margin_right(20);
	m_button.set_margin_bottom(20);
	m_button.set_margin_left(20);
	add(m_button);

	//
	// フォーカスを取得しないようにします。
	//
	set_accept_focus(false);

	//
	// 起動時にフォーカスを取得しないようにします。
	// (set_accept_focusの指定だけでは起動時にウィンドウにフォーカスが当たってしまいます)
	//
	set_focus_on_map(false);

	show_all();
}

NoActivateWindow::~NoActivateWindow()
{
}

void NoActivateWindow::on_realize()
{
	Gtk::Window::on_realize();

#ifdef _WIN32
	HWND hwnd = gdk_win32_window_get_impl_hwnd(get_window()->gobj());
	LONG ex_style = GetWindowLongA(hwnd, GWL_EXSTYLE);
	SetWindowLongA(hwnd, GWL_EXSTYLE, (ex_style | WS_EX_NOACTIVATE));
#endif
}
